;---------------------------------------
; GetInstallInfo
;
; Arguments: toReport -  1, 0 report errors
;
; Returns:
;   HOT_OK/HOT_ERR
;
; Description:
;   Reads win.registry for installed program
;   paths and version.
;---------------------------------------
GetInstallInfo(toReport)
{
    global

    RegRead, PROG_INSTALL_VER, HKEY_CURRENT_USER, %PROG_REG_KEY%, Version
    if ErrorLevel
    {
        if toReport
        Report("Error", PROGRAM_INSTALL_NAME . " not found on this computer. Reg.value not found:[Version]")
        return %HOT_ERR%
    }

    RegRead, SetupPath, HKEY_CURRENT_USER, %PROG_REG_KEY%, Path
    if ErrorLevel
    {
        if toReport
        Report("Error", PROGRAM_INSTALL_NAME . " not found on this computer. Reg.value not found:[Path]")
        return %HOT_ERR%
    }

    return %HOT_OK%
}