;-------------------------------------------------------------------------------
; setup   gui
;
;   Copyright (C) 2008, 2009 Alesc
;   This program is free software: you can redistribute it and/or modify
;   it under the terms of the GNU General Public License.
;-------------------------------------------------------------------------------
CreateUninstallGUI()
{
    global

    SETUP_STATE = 1
    SETUP_ERROR_STATE = 4
    HEADER_TXT_STATE1 = Welcome to uninstall wizard for %PROGRAM_INSTALL_NAME%.
    MAIN_TXT_STATE1 = %PROGRAM_INSTALL_NAME% will be uninstalled from the following folder. Click uninstall to start uninstallation.
    HEADER_TXT_STATE2 = Uninstalling
    MAIN_TXT_STATE2 = Please wait while %PROGRAM_INSTALL_NAME% is beeing uninstalled.
    HEADER_TXT_STATE3 = %PROGRAM_INSTALL_NAME% has been uninstalled from your computer.
    MAIN_TXT_STATE3 = Click End to close this wizard.
    HEADER_TXT_STATE4 = Some error happened during uninstall. %PROGRAM_INSTALL_NAME% has not been uninstalled from your computer.
    MAIN_TXT_STATE4 = Click End to close this wizard.

    Gui, %uninstalll_GUIhandle%:font, Bold
    Gui, %uninstalll_GUIhandle%:Add, Text, x76 y74 w330 h50 vHeaderTxt Bold, %HEADER_TXT_STATE1%
    Gui, %uninstalll_GUIhandle%:font, Norm
    Gui, %uninstalll_GUIhandle%:Add, Text, x76 y174 w330 h50 vMainTxt, %MAIN_TXT_STATE1%

    ; first page
    Gui, %uninstalll_GUIhandle%:Add, GroupBox, x70 y244 w380 h60 vSetupBox, Uninstalling from:
    Gui, %uninstalll_GUIhandle%:Add, Edit, x76 y274 w310 h20 +Disabled vSetupPath,
    GuiControl, %uninstalll_GUIhandle%:, SetupPath, %SetupPath%

    ; second page
    Gui, %uninstalll_GUIhandle%:Add, Text, x76 y234 w310 h40 vProgressTxt Hidden
    Gui, %uninstalll_GUIhandle%:Add, Progress, x76 y274 w310 h20 vSetupProgress Hidden

    ; common code
    Gui, %uninstalll_GUIhandle%:Add, GroupBox, x10 y50 w460 h15,
    Gui, %uninstalll_GUIhandle%:Add, Picture, x10 y2 w50 h-1, %SETUP_TMP_PATH%\resources\setup_stamp.gif
    Gui, %uninstalll_GUIhandle%:Add, Picture, x80 y10 w300 h-1 AltSubmit, %SETUP_TMP_PATH%\resources\setup_title.gif
    Gui, %uninstalll_GUIhandle%:Add, GroupBox, x10 y305 w460 h15,
    Gui, %uninstalll_GUIhandle%:Add, Button, x196 y324 w100 h30 -Wrap gSetupNext vNext, &Uninstall
    Gui, %uninstalll_GUIhandle%:Add, Button, x366 y324 w100 h30 -Wrap gSetupCancel vCancel, Cancel

    OnMessage(0x200, "WM_MOUSEMOVE")
    ; show gui
    Gui, Show, x157 y84 w477 h377, Uninstalling %PROGRAM_INSTALL_NAME% %PROG_INSTALL_VER%
}

SetupCancel:
    Gui, %uninstalll_GUIhandle%:Destroy
    DeinitCORElib(TITLE)
    ExitApp
return

SetupNext:
    SETUP_STATE := SETUP_STATE + 1
    UpdateGUIbyState()
return

UpdateGUIbyState()
{
    global
    local instSuccess

    ; end was clicked...exit
    if SETUP_STATE = 4
    {
        SendToPSP("!T", 1, 0)
        SendToPSP("{Right}", 1, 0)
        SendToPSP("{Enter}", 1, 0)
        Gui, %uninstalll_GUIhandle%:Destroy
        DeinitCORElib(TITLE)
        ExitApp
    }

    GuiControl, %uninstalll_GUIhandle%:, HeaderTxt, % HEADER_TXT_STATE%SETUP_STATE%
    GuiControl, %uninstalll_GUIhandle%:, MainTxt, % MAIN_TXT_STATE%SETUP_STATE%

    GuiControl, %uninstalll_GUIhandle%:Hide, SetupPath
    GuiControl, %uninstalll_GUIhandle%:Hide, SetupBox

    GuiControl, %uninstalll_GUIhandle%:Hide, ProgressTxt
    GuiControl, %uninstalll_GUIhandle%:Hide, SetupProgress
    ; go uninstall
    if SETUP_STATE = 2
    {
        GuiControlGet, SetupPath, %uninstalll_GUIhandle%:
        GuiControl, %uninstalll_GUIhandle%:Disabled, Next
        GuiControl, %uninstalll_GUIhandle%:Show, ProgressTxt
        GuiControl, %uninstalll_GUIhandle%:Show, SetupProgress
        instSuccess := Uninstall()
        SETUP_STATE := SETUP_STATE + 1
    }

    ; installaion finised page
    if SETUP_STATE = 3
    {
        GuiControl, %uninstalll_GUIhandle%:Hide, ProgressTxt
        GuiControl, %uninstalll_GUIhandle%:Hide, SetupProgress

        if instSuccess = %HOT_ERR%
        {
            GuiControl, %uninstalll_GUIhandle%:, HeaderTxt, % HEADER_TXT_STATE%SETUP_ERROR_STATE%
            GuiControl, %uninstalll_GUIhandle%:, MainTxt, % MAIN_TXT_STATE%SETUP_ERROR_STATE%
        }
        else
        {
            GuiControl, %uninstalll_GUIhandle%:, HeaderTxt, % HEADER_TXT_STATE%SETUP_STATE%
            GuiControl, %uninstalll_GUIhandle%:, MainTxt, % MAIN_TXT_STATE%SETUP_STATE%
        }

        GuiControl, %uninstalll_GUIhandle%:Disabled, Cancel
        GuiControl, %uninstalll_GUIhandle%:Enable, Next
        GuiControl, %uninstalll_GUIhandle%:, Next, &End
    }

    return
}

UpdateProgressText(action)
{
    global
    GuiControl,, ProgressTxt, %action%
}
UpdateProgressBar()
{
    global
    local InstallIndex

    CURRENT_ACTION := CURRENT_ACTION + 1
    InstallIndex := Ceil((100 * CURRENT_ACTION) / SETUP_ACTIONS)
    GuiControl,, SetupProgress, %InstallIndex%
    GuiControl,, ProgressTxt,
}

WM_MOUSEMOVE()
{
    ; _TT is kept blank for use by the ToolTip command below.
    static CurrControl, PrevControl, _TT
    CurrControl := A_GuiControl

    If (CurrControl <> PrevControl and not InStr(CurrControl, " "))
    {
        ; Turn off any previous tooltip.
        ToolTip
        SetTimer, DisplayToolTip, 1000
        PrevControl := CurrControl
    }
    return

    DisplayToolTip:
    SetTimer, DisplayToolTip, Off
    IfInString, CurrControl, ...
        return
    ; The leading percent sign tell it to use an expression.
    ToolTip % %CurrControl%_TT
    SetTimer, RemoveToolTip, 3000
    return

    RemoveToolTip:
    SetTimer, RemoveToolTip, Off
    ToolTip
    return
}

;-------------------------------------------------------------------------------
; about gui
;-------------------------------------------------------------------------------
AboutSetup()
{
    global

    Gui, %about_GUIhandle%:Color, Green
    Gui, %about_GUIhandle%:Add, Picture, x6 y4 w200 h170 , %SETUP_TMP_PATH%\resources\hots_about.jpg
    Gui, %about_GUIhandle%:Add, Button, x256 y294 w100 h30 gAboutOk, OK
    Gui, %about_GUIhandle%:Font, s15
    Gui, %about_GUIhandle%:Add, Text, x206 y4 w150 h50 cWhite +Center, %TITLE%
    Gui, %about_GUIhandle%:Font, s10
    Gui, %about_GUIhandle%:Add, Text, x210 y90 w180 h20 cWhite +Left, Program version: 
    Gui, %about_GUIhandle%:Font, Bold
    Gui, %about_GUIhandle%:Add, Text, x316 y90 w30 h20 cWhite +Center, %VERSION%
    Gui, %about_GUIhandle%:Font, s10 Norm
    Gui, %about_GUIhandle%:Add, Text, x210 y110 w150 h80 cWhite +Left, Author: 
    Gui, %about_GUIhandle%:Font, Bold
    Gui, %about_GUIhandle%:Add, Text, x315 y110 w50 h80 cWhite +Center, Alesc
    Gui, %about_GUIhandle%:Font, s10 Norm
    Gui, %about_GUIhandle%:Add, Text, x6 y194 cWhite, Home web page:
    Gui, %about_GUIhandle%:Font, s10 Norm underline
    ProjWWW = %PROGRAM_INSTALL_NAME%
    Gui, %about_GUIhandle%:Add, Text, x120 y194 cWhite gLaunchProjWWW vWWW, http://%ProjWWW%.sourceforge.net/
    WWW_TT := "Click"
    Gui, %about_GUIhandle%:Show, Center h343 w369, About Setup
    return
}

AboutOk:
    Gui, %about_GUIhandle%:Destroy
return
